local addonName, addon = ...

addon.groupieListingTable = {}

addon.groupieLocaleTable = {
    ["frFR"] = "French",
    ["deDE"] = "German",
    ["enGB"] = "English",
    ["enUS"] = "English",
    ["itIT"] = "Italian",
    ["koKR"] = "Korean",
    ["zhCN"] = "Chinese",
    ["zhTW"] = "Chinese",
    ["ruRU"] = "Russian",
    ["esES"] = "Spanish",
    ["esMX"] = "Spanish",
    ["ptBR"] = "Portuguese",
}

addon.groupieRoleTable = {
    [1] = "Tank",
    [2] = "Healer",
    [3] = "Ranged DPS",
    [4] = "Melee DPS"
}

addon.groupieClassRoleTable = {
    ["Death Knight"] = {
        ["Blood"] = { [1] = "Tank" },
        ["Frost"] = { [1] = "Tank", [4] = "Melee DPS" },
        ["Unholy"] = { [4] = "Melee DPS" }
    },
    ["Druid"] = {
        ["Balance"] = { [3] = "Ranged DPS" },
        ["Feral Combat"] = { [1] = "Tank", [4] = "Melee DPS" },
        ["Restoration"] = { [2] = "Healer" }
    },
    ["Hunter"] = {
        ["Beast Mastery"] = { [3] = "Ranged DPS" },
        ["Marksmanship"] = { [3] = "Ranged DPS" },
        ["Survival"] = { [3] = "Ranged DPS" }
    },
    ["Mage"] = {
        ["Arcane"] = { [3] = "Ranged DPS" },
        ["Fire"] = { [3] = "Ranged DPS" },
        ["Frost"] = { [3] = "Ranged DPS" }
    },
    ["Paladin"] = {
        ["Holy"] = { [2] = "Healer" },
        ["Protection"] = { [1] = "Tank" },
        ["Retribution"] = { [4] = "Melee DPS" }
    },
    ["Priest"] = {
        ["Discipline"] = { [2] = "Healer" },
        ["Holy"] = { [2] = "Healer" },
        ["Shadow"] = { [3] = "Ranged DPS" }
    },
    ["Rogue"] = {
        ["Assassination"] = { [4] = "Melee DPS" },
        ["Combat"] = { [4] = "Melee DPS" },
        ["Subtlety"] = { [4] = "Melee DPS" }
    },
    ["Shaman"] = {
        ["Elemental"] = { [3] = "Ranged DPS" },
        ["Enhancement"] = { [4] = "Melee DPS" },
        ["Restoration"] = { [2] = "Healer" }
    },
    ["Warlock"] = {
        ["Affliction"] = { [3] = "Ranged DPS" },
        ["Demonology"] = { [3] = "Ranged DPS" },
        ["Destruction"] = { [3] = "Ranged DPS" }
    },
    ["Warrior"] = {
        ["Arms"] = { [4] = "Melee DPS" },
        ["Fury"] = { [4] = "Melee DPS" },
        ["Protection"] = { [1] = "Tank" }
    }
}


--0 - Heroic
--1 - 10 Normal
--2 - 25 Normal
--3 - Heroic 10
--4 - Heroic 25
addon.groupieVersionPatterns = {
    ["h"] = 0,
    ["hc"] = 0,
    ["heroic"] = 0,
    ["10"] = 1,
    ["n10"] = 1,
    ["10n"] = 1,
    ["25"] = 2,
    ["n25"] = 2,
    ["25n"] = 2,
    ["h10"] = 3,
    ["10h"] = 3,
    ["h25"] = 4,
    ["25h"] = 4
}

--0 - Generic group
--1 - Looking for Tank
--2 - Looking for Healer
--3 - Looking for DPS
--4 - LFG
--5 - boost runs
addon.groupieLFPatterns = {
    ["group"] = 0,
    ["lf"] = 0,
    ["lfm"] = 0,
    ["run"] = 0,
    ["runs"] = 0,
    ["running"] = 0,

    ["lftank"] = 1,
    ["lftanks"] = 1,
    ["tank"] = 1,
    ["tanks"] = 1,

    ["lfheal"] = 2,
    ["lfhealer"] = 2,
    ["lfheals"] = 2,
    ["lfhealers"] = 2,
    ["heal"] = 2,
    ["heals"] = 2,
    ["healer"] = 2,
    ["healers"] = 2,

    ["lfdps"] = 3,
    ["dps"] = 3,
    ["melee"] = 3,
    ["ranged"] = 3,
    ["lfmelee"] = 3,
    ["lfranged"] = 3,

    ["lfg"] = 4,

    ["boost"] = 5,
    ["boosts"] = 5,
    ["boosting"] = 5,
    ["wts"] = 5,
    ["carry"] = 5,
    ["ticket"] = 5,
    ["selling"] = 5,
    ["buyer"] = 5
}

addon.groupieUnflippedLootPatterns = {
    ["Ticket"] = "ticket carry boost boosts boosting wts",
    ["GDKP"] = "gdkp",
    ["Soft Reserve"] = "sr softres softreserve soft",
    ["MS>OS"] = "msos"
}

--For now, this only supports English, but implemented such that localization would be easy in the future
addon.groupieUnflippedLanguagePatterns = {
    ["English"] = "english eng",
}

addon.groupieDelimiters = { "%-", ":", ",", "%?", "!", "%." }

addon.multiWingInstances = { "Dire Maul - Full Clear", "Maraudon - Full Clear", "Scarlet Monastery - Full Clear" }

--instanceVersions[instance] = {{size, isHeroic}, ...}
addon.instanceVersions = {
    ["Ragefire Chasm"]                 = { { 5, false } },
    ["Wailing Caverns"]                = { { 5, false } },
    ["The Deadmines"]                  = { { 5, false } },
    ["Shadowfang Keep"]                = { { 5, false } },
    ["The Stockade"]                   = { { 5, false } },
    ["Blackfathom Deeps"]              = { { 5, false } },
    ["Gnomeregan"]                     = { { 5, false } },
    ["Razorfen Kraul"]                 = { { 5, false } },
    ["Scarlet Monastery - Full Clear"] = { { 5, false } },
    ["Scarlet Monastery - Graveyard"]  = { { 5, false } },
    ["Scarlet Monastery - Library"]    = { { 5, false } },
    ["Scarlet Monastery - Armory"]     = { { 5, false } },
    ["Scarlet Monastery - Cathedral"]  = { { 5, false } },
    ["Razorfen Downs"]                 = { { 5, false } },
    ["Uldaman"]                        = { { 5, false } },
    ["Zul'Farrak"]                     = { { 5, false } },
    ["Maraudon - Full Clear"]          = { { 5, false } },
    ["Maraudon - Princess"]            = { { 5, false } },
    ["Maraudon - Purple"]              = { { 5, false } },
    ["Maraudon - Orange"]              = { { 5, false } },
    ["The Temple of Atal'Hakkar"]      = { { 5, false } },
    ["Blackrock Depths"]               = { { 5, false } },
    ["Dire Maul - Full Clear"]         = { { 5, false } },
    ["Dire Maul - East Wing"]          = { { 5, false } },
    ["Dire Maul - North Wing"]         = { { 5, false } },
    ["Dire Maul - West Wing"]          = { { 5, false } },
    ["Lower Blackrock Spire"]          = { { 5, false } },
    ["Stratholme"]                     = { { 5, false } },
    ["Scholomance"]                    = { { 5, false } },

    ["Upper Blackrock Spire"] = { { 10, false } },
    ["Zul'Gurub"]             = { { 20, false } },
    ["Ruins of Ahn'Qiraj"]    = { { 20, false } },
    ["Onyxia's Lair"]         = { { 40, false } },
    ["Molten Core"]           = { { 40, false } },
    ["Blackwing Lair"]        = { { 40, false } },
    ["Temple of Ahn'Qiraj"]   = { { 40, false } },
    --["Naxxramas"]             = { { 40, false } },

    ["Hellfire Ramparts"]       = { { 5, false }, { 5, true } },
    ["The Blood Furnace"]       = { { 5, false }, { 5, true } },
    ["The Slave Pens"]          = { { 5, false }, { 5, true } },
    ["The Underbog"]            = { { 5, false }, { 5, true } },
    ["Mana-Tombs"]              = { { 5, false }, { 5, true } },
    ["Auchenai Crypts"]         = { { 5, false }, { 5, true } },
    ["Sethekk Halls"]           = { { 5, false }, { 5, true } },
    ["Old Hillsbrad Foothills"] = { { 5, false }, { 5, true } },
    ["Shadow Labyrinth"]        = { { 5, false }, { 5, true } },
    ["The Mechanar"]            = { { 5, false }, { 5, true } },
    ["The Shattered Halls"]     = { { 5, false }, { 5, true } },
    ["The Steamvault"]          = { { 5, false }, { 5, true } },
    ["The Botanica"]            = { { 5, false }, { 5, true } },
    ["The Arcatraz"]            = { { 5, false }, { 5, true } },
    ["The Black Morass"]        = { { 5, false }, { 5, true } },
    ["Magisters' Terrace"]      = { { 5, false }, { 5, true } },

    ["Karazhan"]             = { { 10, false } },
    ["Zul'Aman"]             = { { 10, false } },
    ["Gruul's Lair"]         = { { 25, false } },
    ["Magtheridon's Lair"]   = { { 25, false } },
    ["Serpentshrine Cavern"] = { { 25, false } },
    ["The Eye"]              = { { 25, false } },
    ["Hyjal Summit"]         = { { 25, false } },
    ["Black Temple"]         = { { 25, false } },
    ["Sunwell Plateau"]      = { { 25, false } },

    ["Utgarde Keep"]               = { { 5, false }, { 5, true } },
    ["The Nexus"]                  = { { 5, false }, { 5, true } },
    ["Ajzol-Nerub"]                = { { 5, false }, { 5, true } },
    ["Ahn'kahet: The Old Kingdom"] = { { 5, false }, { 5, true } },
    ["Drak'Tharon Keep"]           = { { 5, false }, { 5, true } },
    ["The Violet Hold"]            = { { 5, false }, { 5, true } },
    ["Gundrak"]                    = { { 5, false }, { 5, true } },
    ["Halls of Stone"]             = { { 5, false }, { 5, true } },
    ["The Culling of Stratholme"]  = { { 5, false }, { 5, true } },
    ["Halls of Lightning"]         = { { 5, false }, { 5, true } },
    ["Utgarde Pinnacle"]           = { { 5, false }, { 5, true } },
    ["The Oculus"]                 = { { 5, false }, { 5, true } },
    ["Trial of the Champion"]      = { { 5, false }, { 5, true } },
    ["Forge of Souls"]             = { { 5, false }, { 5, true } },
    ["Pit of Saron"]               = { { 5, false }, { 5, true } },
    ["Halls of Reflection"]        = { { 5, false }, { 5, true } },

    ["Naxxramas"]            = { { 10, false }, { 25, false } },
    ["The Obsidian Sanctum"] = { { 10, false }, { 25, false } },
    ["Vault of Archavon"]    = { { 10, false }, { 25, false } },
    ["The Eye of Eternity"]  = { { 10, false }, { 25, false } },
    --["Onyxia's Lair"]        = { { 10, false }, { 25, false } },
    ["Ulduar"]               = { { 10, false }, { 25, false } },

    ["Crusaders' Coliseum: Trial of the Crusader"] = { { 10, false }, { 25, false }, { 10, true }, { 25, true } },
    ["Icecrown Citadel"]                           = { { 10, false }, { 25, false }, { 10, true }, { 25, true } },
    ["The Ruby Sanctum"]                           = { { 10, false }, { 25, false }, { 10, true }, { 25, true } },
}

addon.groupieInstanceData = {
    ["Heroic The Ruby Sanctum - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Heroic Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3550 },
    ["Heroic Icecrown Citadel - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Heroic Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3540 },
    ["Heroic Crusaders' Coliseum: Trial of the Crusader - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Heroic Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3530 },
    ["Heroic The Ruby Sanctum - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Heroic Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3520 },
    ["Heroic Icecrown Citadel - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Heroic Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3510 },
    ["Heroic Crusaders' Coliseum: Trial of the Crusader - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Heroic Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3500 },
    ["The Ruby Sanctum - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3490 },
    ["Icecrown Citadel - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3480 },
    ["Crusaders' Coliseum: Trial of the Crusader - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3470 },
    ["Ulduar - 25"] = { Active = false, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich Raids - 25",
        InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25, Order = 3460 },
    ["Onyxia's Lair - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3450 },
    ["The Eye of Eternity - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3440 },
    ["Naxxramas - 25"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich Raids - 25",
        InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25, Order = 3430 },
    ["The Obsidian Sanctum - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3420 },
    ["Vault of Archavon - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 25", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 25,
        Order = 3410 },
    ["The Ruby Sanctum - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3400 },
    ["Icecrown Citadel - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3390 },
    ["Crusaders' Coliseum: Trial of the Crusader - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3380 },
    ["Ulduar - 10"] = { Active = false, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich Raids - 10",
        InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10, Order = 3370 },
    ["Onyxia's Lair - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3360 },
    ["The Eye of Eternity - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3350 },
    ["The Obsidian Sanctum - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3340 },
    ["Naxxramas - 10"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich Raids - 10",
        InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10, Order = 3330 },
    ["Vault of Archavon - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich Raids - 10", InstanceID = -1, MinLevel = 80, MaxLevel = 80, GroupSize = 10,
        Order = 3320 },
    ["Heroic Ahn'kahet: The Old Kingdom"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3310 },
    ["Heroic Ajzol-Nerub"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3300 },
    ["Heroic Drak'Tharon Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3290 },
    ["Heroic Gundrak"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3280 },
    ["Heroic Halls of Lightning"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3270 },
    ["Heroic Halls of Reflection"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3260 },
    ["Heroic Halls of Stone"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3250 },
    ["Heroic Pit of Saron"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3240 },
    ["Heroic The Culling of Stratholme"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3230 },
    ["Heroic The Forge of Souls"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3220 },
    ["Heroic The Nexus"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3210 },
    ["Heroic The Oculus"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3200 },
    ["Heroic The Violet Hold"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3190 },
    ["Heroic Trial of the Champion"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3180 },
    ["Heroic Utgarde Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3170 },
    ["Heroic Utgarde Pinnacle"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = -1, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3160 },
    ["Halls of Reflection"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3150 },
    ["Pit of Saron"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3140 },
    ["The Forge of Souls"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3130 },
    ["Trial of the Champion"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3120 },
    ["The Oculus"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5, Order = 3110 },
    ["Utgarde Pinnacle"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3100 },
    ["Halls of Lightning"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3090 },
    ["The Culling of Stratholme"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3080 },
    ["Halls of Stone"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 77, MaxLevel = 82, GroupSize = 5,
        Order = 3070 },
    ["Gundrak"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = -1, MinLevel = 76, MaxLevel = 81, GroupSize = 5, Order = 3060 },
    ["The Violet Hold"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 75, MaxLevel = 80, GroupSize = 5,
        Order = 3050 },
    ["Drak'Tharon Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 74, MaxLevel = 79, GroupSize = 5,
        Order = 3040 },
    ["Ahn'kahet: The Old Kingdom"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 73, MaxLevel = 78, GroupSize = 5,
        Order = 3030 },
    ["Ajzol-Nerub"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = -1, MinLevel = 72, MaxLevel = 77, GroupSize = 5, Order = 3020 },
    ["The Nexus"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = -1, MinLevel = 70, MaxLevel = 76, GroupSize = 5, Order = 3010 },
    ["Utgarde Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75, GroupSize = 5,
        Order = 3000 },
    ["Sunwell Plateau"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2400 },
    ["Black Temple"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2390 },
    ["Hyjal Summit"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2380 },
    ["The Eye"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2370 },
    ["Serpentshrine Cavern"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2360 },
    ["Magtheridon's Lair"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2350 },
    ["Gruul's Lair"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2340 },
    ["Zul'Aman"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 10, Order = 2330 },
    ["Karazhan"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = -1, MinLevel = 70, MaxLevel = 70, GroupSize = 10, Order = 2320 },
    ["Heroic Auchenai Crypts"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2310 },
    ["Heroic Hellfire Ramparts"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2300 },
    ["Heroic Magisters' Terrace"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2290 },
    ["Heroic Mana-Tombs"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2280 },
    ["Heroic Old Hillsbrad Foothills"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2270 },
    ["Heroic Sethekk Halls"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2260 },
    ["Heroic Shadow Labyrinth"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2250 },
    ["Heroic The Arcatraz"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2240 },
    ["Heroic The Black Morass"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2230 },
    ["Heroic The Blood Furnace"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2220 },
    ["Heroic The Botanica"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2210 },
    ["Heroic The Mechanar"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2200 },
    ["Heroic The Shattered Halls"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2190 },
    ["Heroic The Slave Pens"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2180 },
    ["Heroic The Steamvault"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2170 },
    ["Heroic The Underbog"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2160 },
    ["Magisters' Terrace"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Dungeons", InstanceID = -1, MinLevel = 70, MaxLevel = 75, GroupSize = 5,
        Order = 2150 },
    ["The Black Morass"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 70, MaxLevel = 75, GroupSize = 5, Order = 2140 },
    ["The Steamvault"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 70, MaxLevel = 75, GroupSize = 5, Order = 2130 },
    ["The Arcatraz"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 69, MaxLevel = 75, GroupSize = 5, Order = 2120 },
    ["The Botanica"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 69, MaxLevel = 75, GroupSize = 5, Order = 2110 },
    ["The Shattered Halls"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Dungeons", InstanceID = -1, MinLevel = 69, MaxLevel = 75, GroupSize = 5,
        Order = 2100 },
    ["The Mechanar"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 69, MaxLevel = 75, GroupSize = 5, Order = 2090 },
    ["Shadow Labyrinth"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 69, MaxLevel = 73, GroupSize = 5, Order = 2080 },
    ["Sethekk Halls"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 67, MaxLevel = 72, GroupSize = 5, Order = 2070 },
    ["Old Hillsbrad Foothills"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Dungeons", InstanceID = -1, MinLevel = 66, MaxLevel = 71, GroupSize = 5,
        Order = 2060 },
    ["Auchenai Crypts"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 65, MaxLevel = 70, GroupSize = 5, Order = 2050 },
    ["Mana-Tombs"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 64, MaxLevel = 69, GroupSize = 5, Order = 2040 },
    ["The Underbog"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 62, MaxLevel = 68, GroupSize = 5, Order = 2030 },
    ["The Slave Pens"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 62, MaxLevel = 67, GroupSize = 5, Order = 2020 },
    ["The Blood Furnace"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 61, MaxLevel = 66, GroupSize = 5, Order = 2010 },
    ["Hellfire Ramparts"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = -1, MinLevel = 59, MaxLevel = 65, GroupSize = 5, Order = 2000 },
    ["Naxxramas"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = -1,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1360 },
    ["Temple of Ahn'Qiraj"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids",
        InstanceID = -1, MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1350 },
    ["Blackwing Lair"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = -1,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1340 },
    ["Molten Core"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = -1,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1330 },
    ["Onyxia's Lair"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = -1,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1320 },
    ["Ruins of Ahn'Qiraj"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids",
        InstanceID = -1, MinLevel = 60, MaxLevel = 60, GroupSize = 20, Order = 1310 },
    ["Zul'Gurub"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = -1,
        MinLevel = 60, MaxLevel = 60, GroupSize = 20, Order = 1300 },
    ["Upper Blackrock Spire"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids",
        InstanceID = -1, MinLevel = 60, MaxLevel = 60, GroupSize = 10, Order = 1290 },
    ["Scholomance"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 57, MaxLevel = 65, GroupSize = 5, Order = 1280 },
    ["Stratholme"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 57, MaxLevel = 64, GroupSize = 5, Order = 1270 },
    ["Dire Maul - Full Clear"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 55, MaxLevel = 62, GroupSize = 5, Order = 1260 },
    ["Dire Maul - North Wing"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 58, MaxLevel = 62, GroupSize = 5, Order = 1250 },
    ["Dire Maul - West Wing"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 56, MaxLevel = 61, GroupSize = 5, Order = 1240 },
    ["Dire Maul - East Wing"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 55, MaxLevel = 61, GroupSize = 5, Order = 1230 },
    ["Lower Blackrock Spire"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 54, MaxLevel = 63, GroupSize = 5, Order = 1220 },
    ["Blackrock Depths"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 52, MaxLevel = 59, GroupSize = 5, Order = 1210 },
    ["The Temple of Atal'Hakkar"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 48, MaxLevel = 53, GroupSize = 5, Order = 1200 },
    ["Maraudon - Full Clear"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 42, MaxLevel = 51, GroupSize = 5, Order = 1190 },
    ["Maraudon - Princess"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 46, MaxLevel = 51, GroupSize = 5, Order = 1180 },
    ["Maraudon - Orange"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 44, MaxLevel = 49, GroupSize = 5, Order = 1170 },
    ["Maraudon - Purple"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 42, MaxLevel = 47, GroupSize = 5, Order = 1160 },
    ["Zul'Farrak"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 43, MaxLevel = 49, GroupSize = 5, Order = 1150 },
    ["Uldaman"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 36, MaxLevel = 43, GroupSize = 5, Order = 1140 },
    ["Razorfen Downs"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -
            1, MinLevel = 35, MaxLevel = 44, GroupSize = 5, Order = 1130 },
    ["Scarlet Monastery - Full Clear"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 30, MaxLevel = 43, GroupSize = 5, Order = 1120 },
    ["Scarlet Monastery - Cathedral"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 37, MaxLevel = 43, GroupSize = 5, Order = 1110 },
    ["Scarlet Monastery - Armory"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 35, MaxLevel = 40, GroupSize = 5, Order = 1100 },
    ["Scarlet Monastery - Library"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 33, MaxLevel = 38, GroupSize = 5, Order = 1090 },
    ["Scarlet Monastery - Graveyard"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 30, MaxLevel = 35, GroupSize = 5, Order = 1080 },
    ["Gnomeregan"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 25, MaxLevel = 31, GroupSize = 5, Order = 1070 },
    ["Razorfen Kraul"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -
            1, MinLevel = 24, MaxLevel = 30, GroupSize = 5, Order = 1060 },
    ["The Stockade"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 23, MaxLevel = 28, GroupSize = 5, Order = 1050 },
    ["Blackfathom Deeps"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 23, MaxLevel = 27, GroupSize = 5, Order = 1040 },
    ["Shadowfang Keep"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 18, MaxLevel = 24, GroupSize = 5, Order = 1030 },
    ["Wailing Caverns"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -1, MinLevel = 17, MaxLevel = 25, GroupSize = 5, Order = 1020 },
    ["The Deadmines"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = -1,
        MinLevel = 14, MaxLevel = 23, GroupSize = 5, Order = 1010 },
    ["Ragefire Chasm"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = -
            1, MinLevel = 13, MaxLevel = 19, GroupSize = 5, Order = 1000 }

}


addon.groupieUnflippedDungeonPatterns = {
    ["Ragefire Chasm"]                 = "rfc ragefire chasm",
    ["Wailing Caverns"]                = "wc wailing caverns",
    ["The Deadmines"]                  = "deadmines vc vancleef dead mines mine",
    ["Shadowfang Keep"]                = "sfk shadowfang",
    ["The Stockade"]                   = "stk stock stockade stockades",
    ["Blackfathom Deeps"]              = "bfd blackfathom fathom",
    ["Gnomeregan"]                     = "gnomer gno gnomeregan gnomeragan gnome gnomregan gnomragan gnom gnomergan",
    ["Razorfen Kraul"]                 = "rfk kraul",
    ["Scarlet Monastery - Full Clear"] = "sm scarlet monastery mona",
    ["Scarlet Monastery - Graveyard"]  = "smgy smg gy graveyard",
    ["Scarlet Monastery - Library"]    = "smlib sml lib library",
    ["Scarlet Monastery - Armory"]     = "smarm sma arm armory herod armoury arms",
    ["Scarlet Monastery - Cathedral"]  = "smcath smc cath cathedral",
    ["Razorfen Downs"]                 = "rfd downs",
    ["Uldaman"]                        = "uld ulda uldaman ulduman uldman uldama udaman",
    ["Zul'Farrak"]                     = "zf zul farrak zul'farrak zulfarrak zulfarak zul´farrak zul`farrak zulfa zulf",
    ["Maraudon - Full Clear"]          = "mar mara maraudon mauradon mauro maurodon maraudin maura marau mauraudon",
    ["Maraudon - Princess"]            = "princessrun princess",
    ["Maraudon - Purple"]              = "marpurp marpurple marapurp marapurple maraudonpurple purple, purp",
    ["Maraudon - Orange"]              = "marorange maraorange maraudonorange orange",
    ["The Temple of Atal'Hakkar"]      = "st sunken atal temple",
    ["Blackrock Depths"]               = "brd emperor emp arenarun angerforge blackrockdepth",
    ["Dire Maul - Full Clear"]         = "dm dire maul diremaul",
    ["Dire Maul - East Wing"]          = "dme dmeast east puzilin jumprun",
    ["Dire Maul - North Wing"]         = "dmn dmnorth north tribute",
    ["Dire Maul - West Wing"]          = "dmw dmwest west",
    ["Lower Blackrock Spire"]          = "lower lbrs lrbs",
    ["Stratholme"]                     = "stratlive live living stratUD undead ud baron stratholme stath stratholm strah strath strat starth",
    ["Scholomance"]                    = "scholomance scholo sholo sholomance",

    ["Upper Blackrock Spire"] = "upper ubrs urbs rend",
    ["Zul'Gurub"]             = "zg gurub zul'gurub zulgurub zul´gurub zul`gurub zulg zul-gurub",
    ["Ruins of Ahn'Qiraj"]    = "ruins aq20",
    ["Onyxia's Lair"]         = "onyxia ony",
    ["Molten Core"]           = "molten core mc",
    ["Blackwing Lair"]        = "blackwing bwl",
    ["Temple of Ahn'Qiraj"]   = "aq40",
    ["Naxxramas"]             = "naxxramas nax naxx",

    ["Hellfire Ramparts"]       = "ramparts rampart ramp ramps",
    ["The Blood Furnace"]       = "furnace furn bf",
    ["The Slave Pens"]          = "slavepens pens sp",
    ["The Underbog"]            = "underbog ub",
    ["Mana-Tombs"]              = "manatombs mana mt tomb tombs",
    ["Auchenai Crypts"]         = "crypts crypt auchenai ac acrypts acrypt",
    ["Sethekk Halls"]           = "sethekk seth sethek anzu",
    ["Old Hillsbrad Foothills"] = "ohb oh ohf durnholde hillsbrad escape",
    ["Shadow Labyrinth"]        = "sl slab labyrinth lab",
    ["The Mechanar"]            = "mech mechanar",
    ["The Shattered Halls"]     = "sh shattered shatered shaterred",
    ["The Steamvault"]          = "sv steamvault steamvaults steam vault valts",
    ["The Botanica"]            = "botanica bot",
    ["The Arcatraz"]            = "arc arcatraz alcatraz",
    ["The Black Morass"]        = "morass bm black",
    ["Magisters' Terrace"]      = "mgt mrt terrace magisters magister",

    ["Karazhan"]             = "kara kz karazhan",
    ["Zul'Aman"]             = "za zulaman zul-aman zaman aman zul'aman",
    ["Gruul's Lair"]         = "gl gruul gruuls gruul's",
    ["Magtheridon's Lair"]   = "mag magtheridon magtheridon's magth",
    ["Serpentshrine Cavern"] = "ssc serpentshrine serpentshine",
    ["The Eye"]              = "eye tk",
    ["Hyjal Summit"]         = "hyjal hs hyj",
    ["Black Temple"]         = "bt blacktemple",
    ["Sunwell Plateau"]      = "swp sunwell plateau plataeu sunwel",
}


addon.groupieInstancePatterns = addon.TableFlip(addon.groupieUnflippedDungeonPatterns)
addon.groupieLootPatterns = addon.TableFlip(addon.groupieUnflippedLootPatterns)
addon.groupieLanguagePatterns = addon.TableFlip(addon.groupieUnflippedLanguagePatterns)
